{# Copyright 2020 Karlsruhe Institute of Technology
 #
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at
 #
 #     http://www.apache.org/licenses/LICENSE-2.0
 #
 # Unless required by applicable law or agreed to in writing, software
 # distributed under the License is distributed on an "AS IS" BASIS,
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and
 # limitations under the License. #}

{% extends "records/manage_record_base.html" %}

{% block title %}
  {% if title %}{{ title }} - {% endif %}{% trans %}Export{% endtrans %} -
  {{ record.title | truncate(50, True) }} - {% trans %}Records{% endtrans %} - Kadi4Mat
{% endblock %}

{% block content %}
  <div class="card">
    {% include "records/snippets/manage_record_menu.html" %}

    <div class="card-header">
      <ul class="nav nav-tabs card-header-tabs">
        {% snippet "nav_item",
                   url=url_for("records.view_record", id=record.id),
                   body='<i class="fas fa-chevron-left"></i>' %}

        {% snippet "nav_item",
                   url=url_for("records.export_record", id=record.id, export_type=export_type),
                   body="<strong>{}</strong>".format(_("Export")) %}
      </ul>
    </div>
    <div class="card-body">
      <div class="d-flex align-items-center justify-content-between mb-3">
        <h5 class="mb-0">
          <strong>{{ title }}</strong>
        </h5>
        <a class="btn btn-sm btn-light"
           href="{{ url_for('api.get_record_export', id=record.id, export_type=export_type, download=True) }}">
          {% trans %}Download{% endtrans %}
        </a>
      </div>
      <div class="card bg-light">
        <div v-if="exportData">
          {% if export_type == "json" %}
            <div class="card-body">
              <pre style="max-height: 50vh;">{$ exportData $}</pre>
            </div>
          {% elif export_type == "pdf" %}
            <iframe class="w-100" frameborder="0" style="height: 75vh;" :src="exportData" allowfullscreen></iframe>
          {% elif export_type == "qr" %}
            <div class="text-center">
              <img class="img-fluid" :src="exportData">
            </div>
          {% endif %}
        </div>
        <div class="card-body" v-else>
          <i class="fas fa-circle-notch fa-spin" v-if="!initialized"></i>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

{% block scripts %}
  <script type="application/javascript" nonce="{{ csp_nonce() }}">
    new Vue({
      el: '#vm',
      data: {
        exportData: null,
        initialized: false,
      },
      mounted() {
        axios.get(kadi.js_resources.get_record_export_endpoint)
          .then((response) => this.exportData = response.data)
          .catch((error) => kadi.alert(i18n.t('error.loadExportData'), {xhr: error.request}))
          .finally(() => this.initialized = true);
      },
    });
  </script>
{% endblock %}
